> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Submit an event store query

POST https://rest.test.zuora.com/meters/event-store-queries
Content-Type: application/json

Submits a SQL-style asynchronous query to the Event Store to retrieve and inspect metering events for validation, troubleshooting, and reconciliation. The API returns a `queryId` that can be used to poll and fetch paginated results.

Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/mediation/event-store/submit-event-store-query

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).

### Body (application/json)

This endpoint expects a SubmitEventStoreQueryRequest.

- `query` (string, required) — The query clause.

## Response

### 200

OK

- `success` (boolean, optional) — Indicates whether the request was successful.
- `data` (SubmitEventStoreQueryResponseData, optional) — Contains metadata and result details for the submitted event store query.
- `previousPage` (string, optional) — Cursor or URL for the previous page of audit records, if available. Used for backward pagination.
- `nextPage` (string, optional) — Cursor or URL for the next page of audit records, if available. Used for forward pagination.
- `error` (Error, optional) — Container for error information returned by the API when the request fails.

## Errors

### 400 Bad Request Error

Bad Request - Invalid or missing parameters.

- `errors` (list of ProxyBadRequestResponseErrorsItems, optional)
- `success` (boolean, optional)

### 401 Unauthorized Error

Unauthorized - Authentication failed.

- `success` (boolean, optional) — Whether the API request has succeeded or not.
- `data` (MediationErrorResponseData, optional) — Detailed response information for successful requests (e.g., instance info, job details).
- `error` (MediationErrorResponseError, optional) — Contains error details when the request fails.

### 500 Internal Server Error

Internal Server Error - Unexpected error.

- `reasons` (list of ErrorResponseReasonsItems, optional)

## Types

### SubmitEventStoreQueryResponseData

Contains metadata and result details for the submitted event store query.

- `queryId` (string, optional) — Unique identifier of the submitted event store query. Use this ID to poll for status and fetch results.

### Error

- `code` (string, optional) — Machine-readable error code identifying the failure type.
- `message` (string, optional) — Human-readable description of the error that provides more context about what went wrong.
- `detail` (ErrorDetail, optional) — Additional structured details about the error, such as validation issues or parameter-specific information.

### ProxyBadRequestResponseErrorsItems

- `code` (string, optional) — Machine-readable error code identifying the failure type.
- `message` (string, optional) — Human-readable description of the error that provides more context about what went wrong.

### MediationErrorResponseData

Detailed response information for successful requests (e.g., instance info, job details).

- `id` (string, optional) — The instance ID.
- `sessionId` (string, optional) — The session ID of the meter instance.
- `jobId` (string, optional) — The job ID of the meter instance.
- `meterId` (integer, optional) — The ID of the meter.
- `version` (string, optional) — The meter version.
- `revision` (string, optional) — The meter revision.
- `runType` (integer, optional) — The run type of the instance.
- `runTypeDescription` (string, optional) — The description of the run type.
- `startTime` (string, optional) — The start time of the instance.
- `status` (integer, optional) — The job status of the instance.
- `statusDescription` (string, optional) — The status description of the instance.
- `canExportSummary` (boolean, optional) — Whether the instance can export summary information (internal usage).
- `hasLineageEnabled` (boolean, optional) — Whether lineage is enabled for the meter (internal usage).

### MediationErrorResponseError

Contains error details when the request fails.

- `code` (string, optional) — The error reason code (e.g., "70002006" for authorization errors).
- `message` (string, optional) — A human-readable description of the error.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### ErrorDetail

Additional structured details about the error, such as validation issues or parameter-specific information.

## Examples

**Request**

```json
{
  "query": "select * from usage_event"
}
```

**Response**

```json
{
  "success": true,
  "data": {
    "queryId": "b9a5b91ab34c42b1b9399c0e76245e3f7f76610637ec4d17abdcd4214493814e"
  },
  "previousPage": "null",
  "nextPage": "null"
}
```

**SDK Code**

```python Event Store_submitEventStoreQuery_example
import requests

url = "https://rest.test.zuora.com/meters/event-store-queries"

payload = { "query": "select * from usage_event" }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Event Store_submitEventStoreQuery_example
const url = 'https://rest.test.zuora.com/meters/event-store-queries';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"query":"select * from usage_event"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Event Store_submitEventStoreQuery_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/meters/event-store-queries"

	payload := strings.NewReader("{\n  \"query\": \"select * from usage_event\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Event Store_submitEventStoreQuery_example
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/meters/event-store-queries")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"query\": \"select * from usage_event\"\n}"

response = http.request(request)
puts response.read_body
```

```java Event Store_submitEventStoreQuery_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/meters/event-store-queries")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"query\": \"select * from usage_event\"\n}")
  .asString();
```

```php Event Store_submitEventStoreQuery_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/meters/event-store-queries', [
  'body' => '{
  "query": "select * from usage_event"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Event Store_submitEventStoreQuery_example
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/meters/event-store-queries");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"query\": \"select * from usage_event\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Event Store_submitEventStoreQuery_example
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["query": "select * from usage_event"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/meters/event-store-queries")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```